Sortable

Bootstrap sortable plugin

The Bootstrap sortable plugin is an extension that allows you to move, reorder, sort and organize elements on your website using drag and drop functionality.

To start working with a sortable plugin, see the "Getting Started" tab on this page.


Basic Example

This changes the order of elements in the DOM tree by dragging the element.

  • Item 1
  • Item 2
  • Item 3
  • Item 4
  • Item 5
  • Item 6
  • Item 7
  • Item 8
        
            

        <ul id="sortable" class="list-group">
          <li class="list-group-item active">Item 1</li>
          <li class="list-group-item">Item 2</li>
          <li class="list-group-item">Item 3</li>
          <li class="list-group-item">Item 4</li>
          <li class="list-group-item">Item 5</li>
          <li class="list-group-item">Item 6</li>
          <li class="list-group-item">Item 7</li>
          <li class="list-group-item">Item 8</li>
        </ul>

      
        
    
        
            

        $("#sortable").sortable();

      
        
    

Merging lists

This sorts items between two lists

  • Lion
  • Dog
  • Cat
  • Tiger
  • Fish
  • Bird
  • Falcon
  • Mouse
        
            

        <ul id="sortable1" class="list-group connectedSortable">
          <li class="list-group-item active">Lion</li>
          <li class="list-group-item">Dog</li>
          <li class="list-group-item">Cat</li>
          <li class="list-group-item">Tiger</li>
        </ul>

        <ul id="sortable2" class="list-group connectedSortable">
          <li class="list-group-item active">Fish</li>
          <li class="list-group-item">Bird</li>
          <li class="list-group-item">Falcon</li>
          <li class="list-group-item">Mouse</li>
        </ul>

      
        
    
        
            

        $("#sortable1, #sortable2").sortable({
          connectWith: ".connectedSortable"
        });

      
        
    

Display as grid

Displays items in a sortable grid - this can be used to determine the order in which photos or files are uploaded.

1
2
3
4
5
6
7
8
9
10
11
12
        
            

        <div id="sortable3" class="col-md-5 d-flex flex-center flex-wrap">
          <div class="text-center white-text blue m-2 square">1</div>
          <div class="text-center white-text blue m-2 square">2</div>
          <div class="text-center white-text blue m-2 square">3</div>
          <div class="text-center white-text blue m-2 square">4</div>
          <div class="text-center white-text blue m-2 square">5</div>
          <div class="text-center white-text blue m-2 square">6</div>
          <div class="text-center white-text blue m-2 square">7</div>
          <div class="text-center white-text blue m-2 square">8</div>
          <div class="text-center white-text blue m-2 square">9</div>
          <div class="text-center white-text blue m-2 square">10</div>
          <div class="text-center white-text blue m-2 square">11</div>
          <div class="text-center white-text blue m-2 square">12</div>
        </div>

      
        
    
        
            

        $("#sortable3").sortable();

      
        
    
        
            

        .square {
        height: 90px;
        width: 90px;
        line-height: 90px;
        font-size: 32px;
        }

      
        
    

Drop placeholder

This provides illumination of the place where the element will be placed.

  • Item 1
  • Item 2
  • Item 3
  • Item 4
  • Item 5
  • Item 6
  • Item 7
  • Item 8
        
            

        <ul id="sortable4" class="list-group list-unstyled">
          <li class="list-group-item active">Item 1</li>
          <li class="list-group-item">Item 2</li>
          <li class="list-group-item">Item 3</li>
          <li class="list-group-item">Item 4</li>
          <li class="list-group-item">Item 5</li>
          <li class="list-group-item">Item 6</li>
          <li class="list-group-item">Item 7</li>
          <li class="list-group-item">Item 8</li>
        </ul>

      
        
    
        
            

        $("#sortable4").sortable({
          placeholder: 'drop-placeholder'
        });

      
        
    
        
            

        .drop-placeholder {
          background-color: lightgray;
          height: 3.5em;
          padding-top: 12px;
          padding-bottom: 12px;
          line-height: 1.2em;
        }

      
        
    

Handle empty lists

By default, it is not possible to place an item into an empty list. In this example, this has been changed.

From the first list, it is possible to drag items to an empty list, while from the second list you cannot drag items if the target list is empty.

The dropOnEmpty: false parameter is responsible for this behavior.

  • Lion
  • Dog
  • Cat
  • Tiger
  • Fish
  • Bird
  • Falcon
  • Mouse
        
            

        <ul id="sortable5" class="list-group droptrue">
          <li class="list-group-item active">Lion</li>
          <li class="list-group-item">Dog</li>
          <li class="list-group-item">Cat</li>
          <li class="list-group-item">Tiger</li>
        </ul>

        <ul id="sortable6" class="list-group dropfalse">
          <li class="list-group-item active">Fish</li>
          <li class="list-group-item">Bird</li>
          <li class="list-group-item">Falcon</li>
          <li class="list-group-item">Mouse</li>
        </ul>

        <ul id="sortable7" class="list-group droptrue grey lighten-1 py-2">
        </ul>

      
        
    
        
            

        $("ul.droptrue").sortable({
          connectWith: "ul"
        });

        $("ul.dropfalse").sortable({
          connectWith: "ul",
          dropOnEmpty: false
        });

      
        
    

Include/exclude items

It is possible to exclude items from the ability to sort or drag items before/after them.

  • I'm sortable
  • I'm not sortable or a drop target
  • I'm not sortable or a drop target
  • I'm sortable
  • I'm sortable
  • I'm not sortable
  • I'm not sortable
  • I'm sortable
        
            

        <ul id="sortable8" class="list-group">
          <li class="list-group-item active ui-state-default">I'm sortable</li>
          <li class="list-group-item ui-state-default ui-state-disabled disabled">I'm not sortable or a drop
            target</li>
          <li class="list-group-item ui-state-default ui-state-disabled disabled">I'm not sortable or a drop
            target</li>
          <li class="list-group-item ui-state-default">I'm sortable</li>
        </ul>

        <ul id="sortable9" class="list-group">
          <li class="list-group-item active ui-state-default">I'm sortable</li>
          <li class="list-group-item ui-state-default ui-state-disabled disabled">I'm not sortable</li>
          <li class="list-group-item ui-state-default ui-state-disabled disabled">I'm not sortable</li>
          <li class="list-group-item ui-state-default">I'm sortable</li>
        </ul>

      
        
    
        
            

        $("#sortable8").sortable({
          items: "li:not(.ui-state-disabled)"
        });

        $("#sortable9").sortable({
          cancel: ".ui-state-disabled"
        });

      
        
    

Sortable collapsed cards

Cards with collapsed content and sorting between lists - similar behavior can be observed on Trello.

Feeds
Lorem ipsum dolor sit amet, consectetuer adipiscing elit
News
Lorem ipsum dolor sit amet, consectetuer adipiscing elit
Shopping
Lorem ipsum dolor sit amet, consectetuer adipiscing elit
Links
Images
Lorem ipsum dolor sit amet, consectetuer adipiscing elit
        
            

        <div class="col-md-4 mx-auto my-5 blue pb-4 white-text">
          <div class="column">

            <div class="portlet">
              <div class="portlet-header blue darken-3 py-2 my-3 text-center white-text collapseButton" data-toggle="collapse"
                href="#feeds">Feeds <i class="fas fa-caret-down  ml-2"></i></div>
              <div class="portlet-content collapse text-center" id="feeds">Lorem ipsum dolor sit amet,
                consectetuer
                adipiscing elit</div>
            </div>

            <div class="portlet">
              <div class="portlet-header blue darken-3 py-2 my-3 text-center white-text collapseButton" data-toggle="collapse"
                href="#news">News <i class="fas fa-caret-down  ml-2"></i></div>
              <div class="portlet-content collapse text-center" id="news">Lorem ipsum dolor sit amet,
                consectetuer
                adipiscing elit</div>
            </div>

          </div>
        </div>

        <div class="col-md-4 mx-auto my-5 blue pb-4 white-text">
          <div class="column">

            <div class="portlet">
              <div class="portlet-header blue darken-3 py-2 my-3 text-center white-text collapseButton" data-toggle="collapse"
                href="#shopping">Shopping <i class="fas fa-caret-down  ml-2"></i></div>
              <div class="portlet-content  collapse text-center" id="shopping">Lorem ipsum dolor sit amet,
                consectetuer
                adipiscing elit</div>
            </div>

          </div>
        </div>

        <div class="col-md-4 mx-auto my-5 blue pb-4 white-text">
          <div class="column">

            <div class="portlet">
              <div class="portlet-header blue darken-3 py-2 my-3 text-center white-text collapseButton" data-toggle="collapse"
                href="#links">Links <i class="fas fa-caret-down  ml-2"></i></div>
              <div class="portlet-content collapse text-center" id="links">Lorem ipsum dolor sit amet,
                consectetuer
                adipiscing elit</div>
            </div>

            <div class="portlet">
              <div class="portlet-header blue darken-3 py-2 my-3 text-center white-text collapseButton" data-toggle="collapse"
                href="#images">Images <i class="fas fa-caret-down  ml-2"></i></div>
              <div class="portlet-content collapse text-center" id="images">Lorem ipsum dolor sit amet,
                consectetuer
                adipiscing elit</div>
            </div>

          </div>
        </div>

      
        
    
        
            

        $(".column").sortable({
          connectWith: ".column",
          handle: ".portlet-header",
          cancel: ".portlet-toggle",
          placeholder: "drop-placeholder"
        });

        $('.portlet-header').on('click', function (e) {
          if ($(e.target).children().last().hasClass('fa-caret-down')) {
            $(e.target).children().last().removeClass('fa-caret-down').addClass('fa-caret-up');
          } 
          else if ($(e.target).children().last().hasClass('fa-caret-up')) {
            $(e.target).children().last().removeClass('fa-caret-up').addClass('fa-caret-down');
          }
        });

      
        
    

Sortable deck of cards

Cards with collapsed content and sorting between lists - similar behavior can be observed on Trello.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

        
            

        <!-- Card deck -->
        <div class="card-deck">

          <div class="sortable-card col-md-4">
            <!-- Card -->
            <div class="card mb-4">

              <!--Card image-->
              <div class="view overlay">
                <img class="card-img-top" src="https://mdbootstrap.com/img/Photos/Others/images/16.webp" alt="Card image cap">
                <a href="#!">
                  <div class="mask rgba-white-slight"></div>
                </a>
              </div>

              <!--Card content-->
              <div class="card-body">

                <!--Title-->
                <h4 class="card-title">Card title</h4>
                <!--Text-->
                <p class="card-text">Some quick example text to build on the card title and make up the
                  bulk of
                  the card's content.</p>
                <!-- Provides extra visual weight and identifies the primary action in a set of buttons -->
                <button type="button" class="btn btn-light-blue btn-md">Read more</button>

              </div>

            </div>
            <!-- Card -->
          </div>

          <div class="sortable-card col-md-4">
            <!-- Card -->
            <div class="card mb-4">

              <!--Card image-->
              <div class="view overlay">
                <img class="card-img-top" src="https://mdbootstrap.com/img/Photos/Others/images/14.webp" alt="Card image cap">
                <a href="#!">
                  <div class="mask rgba-white-slight"></div>
                </a>
              </div>

              <!--Card content-->
              <div class="card-body">

                <!--Title-->
                <h4 class="card-title">Card title</h4>
                <!--Text-->
                <p class="card-text">Some quick example text to build on the card title and make up the
                  bulk of
                  the card's content.</p>
                <!-- Provides extra visual weight and identifies the primary action in a set of buttons -->
                <button type="button" class="btn btn-light-blue btn-md">Read more</button>

              </div>

            </div>
            <!-- Card -->
          </div>

          <div class="sortable-card col-md-4">
            <!-- Card -->
            <div class="card mb-4">

              <!--Card image-->
              <div class="view overlay">
                <img class="card-img-top" src="https://mdbootstrap.com/img/Photos/Others/images/15.webp" alt="Card image cap">
                <a href="#!">
                  <div class="mask rgba-white-slight"></div>
                </a>
              </div>

              <!--Card content-->
              <div class="card-body">

                <!--Title-->
                <h4 class="card-title">Card title</h4>
                <!--Text-->
                <p class="card-text">Some quick example text to build on the card title and make up the
                  bulk of
                  the card's content.</p>
                <!-- Provides extra visual weight and identifies the primary action in a set of buttons -->
                <button type="button" class="btn btn-light-blue btn-md">Read more</button>

              </div>

            </div>
            <!-- Card -->
          </div>

        </div>
        <!-- Card deck -->

      
        
    
        
            

        $(".card-deck").sortable({
          connectWith: '.card-deck'
        });

      
        
    

Sortable masonry panels

Sortable panels in masonry style. A similar behavior is used by Pinterest.

Panel title that wraps to a new line

This is a longer panel with supporting text below as a natural lead-in to additional content. This content is a little bit longer.

Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.

Someone famous in Source Title
Panel title

This panel has supporting text below as a natural lead-in to additional content.

Last updated 3 mins ago

Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat.

Someone famous in Source Title
Panel title

This panel has supporting text below as a natural lead-in to additional content.

Last updated 3 mins ago

Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.

Someone famous in Source Title
Panel title

This is a wider panel with supporting text below as a natural lead-in to additional content. This panel has even longer content than the first to show that equal height action.

Last updated 3 mins ago

        
            

        <div class="card-columns">

          <div class="sortable">
            <!--Panel-->
            <div class="card">
              <div class="card-body">
                <h5 class="card-title">Panel title that wraps to a new line</h5>
                <p class="card-text">This is a longer panel with supporting text below as a natural
                  lead-in
                  to
                  additional content. This content is a little bit longer.</p>
              </div>
            </div>
            <!--/.Panel-->
          </div>

          <div class="sortable">
            <!--Panel-->
            <div class="card p-3">
              <blockquote class="blockquote mb-0 card-body">
                <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a
                  ante.</p>
                <footer class="blockquote-footer">
                  <small class="text-muted">
                    Someone famous in <cite title="Source Title">Source Title</cite>
                  </small>
                </footer>
              </blockquote>
            </div>
            <!--/.Panel-->
          </div>

          <div class="sortable">
            <!--Panel-->
            <div class="card">
              <div class="card-body">
                <h5 class="card-title">Panel title</h5>
                <p class="card-text">This panel has supporting text below as a natural lead-in to
                  additional
                  content.</p>
                <p class="card-text"><small class="text-muted">Last updated 3 mins ago</small></p>
              </div>
            </div>
            <!--/.Panel-->
          </div>

          <div class="sortable">
            <!--Panel-->
            <div class="card bg-primary text-white text-center p-3">
              <blockquote class="blockquote mb-0">
                <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat.</p>
                <footer class="blockquote-footer">
                  <small>
                    Someone famous in <cite title="Source Title">Source Title</cite>
                  </small>
                </footer>
              </blockquote>
            </div>
            <!--/.Panel-->
          </div>

          <div class="sortable">
            <!--Panel-->
            <div class="card text-center">
              <div class="card-body">
                <h5 class="card-title">Panel title</h5>
                <p class="card-text">This panel has supporting text below as a natural lead-in to
                  additional
                  content.</p>
                <p class="card-text"><small class="text-muted">Last updated 3 mins ago</small></p>
              </div>
            </div>
            <!--/.Panel-->
          </div>

          <div class="sortable">
            <!--Panel-->
            <div class="card p-3 text-right">
              <blockquote class="blockquote mb-0">
                <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a
                  ante.</p>
                <footer class="blockquote-footer">
                  <small class="text-muted">
                    Someone famous in <cite title="Source Title">Source Title</cite>
                  </small>
                </footer>
              </blockquote>
            </div>
            <!--/.Panel-->
          </div>

          <div class="sortable">
            <!--Panel-->
            <div class="card">
              <div class="card-body">
                <h5 class="card-title">Panel title</h5>
                <p class="card-text">This is a wider panel with supporting text below as a natural
                  lead-in
                  to
                  additional content. This panel has even longer content than the first to show that
                  equal
                  height action.</p>
                <p class="card-text"><small class="text-muted">Last updated 3 mins ago</small></p>
              </div>
            </div>
            <!--/.Panel-->
          </div>

        </div>

      
        
    
        
            

        $(".sortable").sortable({
          connectWith: 'div'
        });

      
        
    

Sortable - getting started : download & setup


Download

This plugin requires a purchase.

Buy sortable plugin

Tutorial

Angular Bootstrap Sortable
Angular Sortable - Bootstrap 4 & Material Design
Note: This documentation is for an older version of Bootstrap (v.4). A
newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for
Bootstrap 5.
Go to docs v.5
Angular Bootstrap sortable plugin is an extension that allows you to move, reorder, sort and organize elements on your website by using drag and drop functionality.
To start working with sortable plugin see "Getting Started" tab on this page.
Basic Example
Change the order of elements in the DOM tree by dragging the element.
- Item 1
- Item 2
- Item 3
- Item 4
- Item 5
- Item 6
- Item 7
- Item 8
<ul mdbSortableList class="list-group" (drop)="onDrop($event)">
<li *ngFor="let item of sortableList" mdbSortable class="list-group-item">{{ item }}</li>
</ul>
import { Component } from '@angular/core';
import { moveItemInList } from 'mdb-sortable';
@Component({
selector: 'sortable-example',
templateUrl: './sortable-example.component.html',
})
export class SortableExampleComponent {
sortableList = [
'Item 1',
'Item 2',
'Item 3',
'Item 4',
'Item 5',
'Item 6',
'Item 7',
'Item 8',
'Item 9',
'Item 10'
];
onDrop(event: any) {
moveItemInList(this.sortableList, event.oldIndex, event.newIndex);
}
}
.mdb-sortable {
user-select: none;
}
.mdb-sortable-placeholder {
opacity: 0;
}
Merging lists
Sorting items between two lists
- Lion
- Dog
- Cat
- Tiger
- Fish
- Bird
- Falcon
- Mouse
<div class="row">
<div class="col-md-6 mx-auto">
<ul #list1="mdbSortableList" mdbSortableList [data]="sortableList1" [connectedWith]="[list2]" class="list-group w-100" (drop)="onDrop($event)">
<li *ngFor="let item of sortableList1" class="list-group-item" mdbSortable>{{ item }}</li>
</ul>
</div>
<div class="col-md-6 mx-auto">
<ul #list2="mdbSortableList" mdbSortableList [data]="sortableList2" [connectedWith]="[list1]" class="list-group w-100" (drop)="onDrop($event)">
<li *ngFor="let item of sortableList2" class="list-group-item" mdbSortable>{{ item }}</li>
</ul>
</div>
</div>
import { Component } from '@angular/core';
import { moveItemInList, moveItemToNewList } from 'mdb-sortable';
@Component({
selector: 'sortable-example',
templateUrl: './sortable-example.component.html',
})
export class SortableExampleComponent {
sortableList1 = [
'Lion',
'Dog',
'Cat',
'Tiger'
];
sortableList2 = [
'Fish',
'Bird',
'Falcon',
'Mouse'
];
onDrop(event: any) {
if (event.previousList === event.currentList) {
moveItemInList(event.previousList.data, event.oldIndex, event.newIndex);
} else {
moveItemToNewList(event.previousList.data,
event.currentList.data, event.oldIndex, event.newIndex);
}
}
}
.mdb-sortable {
user-select: none;
}
.mdb-sortable-placeholder {
opacity: 0;
}
Display as grid
Displays items in a sortable grid - this can be used to determine the order in which photos or files are uploaded.
<div mdbSortableList class="col-md-5 d-flex flex-center flex-wrap mt-5" (drop)="onDrop($event)">
<div *ngFor="let item of sortableList" mdbSortable class="text-center white-text blue m-2 square">{{ item }}</div>
</div>
import { Component } from '@angular/core';
import { moveItemInList, moveItemToNewList } from 'mdb-sortable';
@Component({
selector: 'sortable-example',
templateUrl: './sortable-example.component.html',
})
export class SortableExampleComponent {
sortableList = [
'1',
'2',
'3',
'4',
'5',
'6',
'7',
'8',
'9',
'10',
'11',
'12'
];
onDrop(event: any) {
moveItemInList(this.sortableList, event.oldIndex, event.newIndex);
}
}
.mdb-sortable {
user-select: none;
}
.mdb-sortable-placeholder {
opacity: 0;
}
.square {
height: 90px;
width: 90px;
line-height: 90px;
font-size: 32px;
}
Disabled items
It is possible to disable sorting functionality by using [disabled]="true" input.
- Sortable item
- Disabled sortable item
- Disabled sortable item
- Sortable item
<ul mdbSortableList class="list-group" (drop)="onDrop($event)">
<li *ngFor="let item of sortableList" mdbSortable class="list-group-item" [disabled]="item.disabled">{{ item.name }}</li>
</ul>
import { Component } from '@angular/core';
import { moveItemInList } from 'mdb-sortable';
@Component({
selector: 'sortable-example',
templateUrl: './sortable-example.component.html',
})
export class SortableExampleComponent {
sortableList = [
{ name: 'Sortable item', disabled: false },
{ name: 'Disabled sortable item', disabled: true },
{ name: 'Disabled sortable item', disabled: true },
{ name: 'Sortable item', disabled: false },
];
onDrop(event: any) {
moveItemInList(this.sortableList, event.oldIndex, event.newIndex);
}
}
.mdb-sortable {
user-select: none;
}
.mdb-sortable-placeholder {
opacity: 0;
}
.mdb-sortable-disabled {
color: lightgray;
}
Sortable deck of cards
Cards with collapsed content and sorting between lists - similar behavior can be observed on Trello.
Card title
Some quick example text to build on the card title and make up the bulk of the card's content.
Card title
Some quick example text to build on the card title and make up the bulk of the card's content.
Card title
Some quick example text to build on the card title and make up the bulk of the card's content.
<div class="card-deck" mdbSortableList>
<!-- Card -->
<mdb-card mdbSortable>
<div class="view overlay waves-light" mdbWavesEffect>
<!-- Card img -->
<mdb-card-img src="https://mdbootstrap.com/img/Photos/Others/images/16.webp" alt="Card image cap"></mdb-card-img>
<a>
<div class="mask rgba-white-slight"></div>
</a>
</div>
<!--Card content-->
<mdb-card-body>
<!--Title-->
<mdb-card-title>
<h4>Card Title</h4>
</mdb-card-title>
<!--Text-->
<mdb-card-text> Some quick example text to build on the card title and make up the bulk of the card's
content.
</mdb-card-text>
<a href="#" mdbBtn color="primary" mdbWavesEffect>Button</a>
</mdb-card-body>
</mdb-card>
<!-- Card -->
<mdb-card mdbSortable>
<div class="view rgba-white-slight waves-light" mdbWavesEffect>
<!-- Card img -->
<mdb-card-img src="https://mdbootstrap.com/img/Photos/Others/images/14.webp" alt="Card image cap"></mdb-card-img>
<a>
<div class="mask"></div>
</a>
</div>
<!--Card content-->
<mdb-card-body>
<!--Title-->
<mdb-card-title>
<h4>Card Title</h4>
</mdb-card-title>
<!--Text-->
<mdb-card-text> Some quick example text to build on the card title and make up the bulk of the card's
content.
</mdb-card-text>
<a href="#" mdbBtn color="primary" mdbWavesEffect>Button</a>
</mdb-card-body>
</mdb-card>
<!-- Card -->
<mdb-card mdbSortable>
<div class="view rgba-white-slight waves-light" mdbWavesEffect>
<!-- Card img -->
<mdb-card-img src="https://mdbootstrap.com/img/Photos/Others/images/15.webp" alt="Card image cap"></mdb-card-img>
<a>
<div class="mask"></div>
</a>
</div>
<!--Card content-->
<mdb-card-body>
<!--Title-->
<mdb-card-title>
<h4>Card Title</h4>
</mdb-card-title>
<!--Text-->
<mdb-card-text> Some quick example text to build on the card title and make up the bulk of the card's
content.
</mdb-card-text>
<a href="#" mdbBtn color="primary" mdbWavesEffect>Button</a>
</mdb-card-body>
</mdb-card>
</div>
.mdb-sortable {
user-select: none;
}
.mdb-sortable-placeholder {
opacity: 0;
}
Installation guide
Step 1: Create new Angular application using Angular CLI command:
ng new application-name --style=scss --routing=false
Step 2: Download this plugin from your user dashboard
Step 3: Extract downloaded archive from Step 2 and copy mdb-sortable-{version-number}.tgz
file to your application root directory
Step 4: Install the mdb-sortable-{version-number}.tgz package in your application by executing the below command in the application's terminal:
npm install mdb-sortable-{version-number.tgz} --save
For example, the installation command should look like following: npm install mdb-sortable-8.0.0.tgz --save
Step 5: Follow the Quickstart Guide to add MDB Angular Free or MDB Angular Pro (depending on which version you're using) to the application
Step 6: Import the MdbSortableModule in the app.module.ts file
Step 7: Copy the basic example from this site and enjoy your new plugin!
Step 1: Download this plugin from your user dashboard
Step 2: Extract downloaded archive from Step 1 and copy mdb-sortable-{version-number}.tgz
file to your application root directory
Step 3: Install the mdb-sortable-{version-number}.tgz package in your application by executing the below command in the application's terminal:
npm install mdb-sortable-{version-number.tgz} --save
For example, the installation command should look like following: npm install mdb-sortable-8.0.0.tgz --save
Step 4: Follow the Quickstart Guide to add MDB Angular Free or MDB Angular Pro (depending on which version you're using) to the application
Step 5: Import the MdbSortableModule in the app.module.ts file
Step 6: Copy the basic example from this site and enjoy your new plugin!
Angular Sortable - API
Download
This plugin requires a purchase.
Buy sortable plugin
Directives
MdbSortableListDirective
Selector: mdbSortableList
Type: MdbSortableListDirective
MdbSortableDirective
Selector: mdbSortable
Type: MdbSortableDirective
Inputs
MdbSortableList
| Name | Type | Default | Description | Example |
|---|---|---|---|---|
autoScroll |
boolean | false | Automatically update scroll position of sortable list when dragging sortable item | [autoScroll]="true" |
connectedWith |
MdbSortableList[] | - | Array of other lists connected to sortable list | [connectedWith]="sortableList" |
data |
any[] | - | Array of sortable items | [data]="sortableItems" |
MdbSortable
| Name | Type | Default | Description | Example |
|---|---|---|---|---|
disabled |
boolean | false | Specifies disabled state of sortable item | [disabled]="true" |
disabledDragElements |
ElementRef[] | null | Specifies the element on which sortable should be disabled (use it if you want some element, eg. button on which you want to call events) | [disabledDragElements]="[#template-element-ref]" |
Outputs
MdbSortableList
| Name | Type | Description | Example |
|---|---|---|---|
drop |
EventEmitter<{ currentList: MdbSortableListDirective, previousList: MdbSortableListDirective, oldIndex: number, newIndex: number }> | Event fired when sortable item is dropped in sortable list | (drop)="onDrop($event)" |
MdbSortable
| Name | Type | Description | Example |
|---|---|---|---|
dragStart |
EventEmitter<MdbSortableDirective> | Event fired on drag start of sortable item | (dragStart)="onDragStart($event)" |
dragEnd |
EventEmitter<MdbSortableDirective> | Event fired on drag end of sortable item | (dragEnd)="onDragEnd($event)" |

React Bootstrap Sortable

React Sortable - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

React bootstrap sortable plugin is an extension that allows you to move, reorder, sort and organize elements on your website by using drag and drop functionality.

React sortable plugin can be used on smartphones and provides an opportunity to sort elements using keyboard.

To see the list of all properties and methods of the plugin see "API" tab on this page.


Sorting By The "Y" Axis

Change the order of elements by the "y" axis in the DOM tree by dragging the element.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import "./index.css";
        
        const Item = (props) => `Item ${props.title}`;
        
        function App() {
          const items = ["1", "2", "3", "4", "5", "6", "7", "8", "9"];
        
          const renderedItems = items.map((item) => {
            return <Item title={item} />;
          });
        
          return (
            <div>
              <MDBSortable
                axis="y"
                items={renderedItems}
                itemClassName="SortableItem"
              />
            </div>
          );
        }
        
        export default App;
        
     
        
    
        
            
      .SortableItem {
        font-size: 1rem;
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        cursor: move;
      }
    
        
    

Sorting By The "X" Axis

Change the order of elements by the "x" axis in the DOM tree by dragging the element.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import './index.css';
        
        const Item = props => `Item ${props.title}`;
        
        function App() {
          const items = ["1", "2", "3", "4", "5", "6", "7", "8", "9"];
        
          const renderedItems = items.map(item => {
            return <Item title={item} />;
          });
        
          return (
              <div>
                  <MDBSortable
                    axis="x"
                    items={renderedItems}
                    itemClassName="SortableItem"
                    listClassName="SortableList"
                  />
                </div>
          );
        }
        
        export default App;
      
        
    
        
            
        .SortableItem {
          font-size: 1rem;
          padding: 15px 20px;
          list-style: none;
          background-color: #007bff;
          color: #fff;
          margin: 2px;
          display: flex;
          align-items: center;
          justify-content: flex-start;
          cursor: move;
        }
        
        .SortableList {
          display: flex;
        }
      
        
    

Lock axis

You can lock movement to an axis while sorting.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import "./index.css";
        
        const Item = (props) => `Item ${props.title}`;
        
        function App() {
          const items = ["1", "2", "3", "4", "5", "6", "7", "8", "9"];
        
          const renderedItems = items.map((item) => {
            return <Item title={item} />;
          });
        
          return (
            <div>
              <MDBSortable
                axis="y"
                lockAxis="y"
                items={renderedItems.slice(0, 3)}
                itemClassName="SortableItem"
              />
              <MDBSortable
                axis="x"
                lockAxis="x"
                items={renderedItems}
                itemClassName="SortableItem"
                listClassName="SortableList"
              />
            </div>
          );
        }
        export default App;
        
     
        
    
        
            
      .SortableItem {
        font-size: 1rem;
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        cursor: move;
      }
  
      .SortableList {
        display: flex;
      }
    
        
    

Display as grid

Displays items in a sortable grid - this can be used to determine the order in which photos or files are uploaded.
To avoid incorrect display of elements useWindowAsScrollContainer property should be set to false and items container width should be set to minimum required for items.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import "./index.css";
        
        const Item = (props) => `Item ${props.title}`;
        
        function App() {
          const items = ["1", "2", "3", "4", "5", "6", "7", "8", "9"];
        
          const renderedItems = items.map((item) => {
            return <Item title={item} />;
          });
        
          return (
            <div>
              <MDBSortable
                axis="xy"
                items={renderedItems}
                itemClassName="SortableItem"
                listClassName="SortableList"
              />
            </div>
          );
        }
        
        export default App;
        
     
        
    
        
            
      .SortableItem {
        font-size: 1rem;
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: center;
        cursor: move;
      }

      .SortableList {
        width: 450px;
        display: grid;
        grid-template-rows: repeat(3, 150px);
        grid-template-columns: repeat(3, 150px);
      }
    
        
    

Include / exclude items

It is possible to exclude items from the possibility of sorting or dragging items before / after them.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import "./index.css";
        
        const Item = (props) => `Item ${props.title}`;
        
        function App() {
          const items = [
            {
              title: "1",
              disabled: false,
            },
            {
              title: "2",
              disabled: true,
            },
            {
              title: "3",
              disabled: false,
            },
          ];
        
          const disabledItems = items.map((item) => (
            <Item title={item.title} disabled={item.disabled} />
          ));
        
          return (
            <div>
              <MDBSortable
                axis="y"
                items={disabledItems}
                itemClassName="SortableItem"
                disabledClassName="disabled"
              />
            </div>
          );
        }
        
        export default App;
        
     
        
    
        
            
      .SortableItem {
        font-size: 1rem;
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        cursor: move;
      }
      
      .SortableItem.disabled {
        background-color: #eee;
        color: #333;
      }      
    
        
    

Styling sortable element

You can add your own styles to sortable element.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import './index.css';

        const Item = props => `Item ${props.title}`;

        function App() {
          const items = ["1", "2", "3"];

          const renderedItems = items.map(item => {
            return <Item title={item} />;
          });

          return (
            <div>
              <MDBSortable
                helperClass="helperClass"
                axis="y"
                items={renderedItems}
                itemClassName="SortableItem"
              />
            </div>
          );
        }

        export default App;
     
        
    
        
            
      .SortableItem {
        font-size: 1rem;
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        cursor: move;
      }
    
      .helperClass {
        box-shadow: 0px 0px 5px 0px rgba(0, 0, 0, 0.5);
      }
    
        
    

Delay before sorting begins

Makes element sortable after being pressed for a certain time.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import './index.css';

        const Item = props => `Item ${props.title}`;

        function App() {
          const items = ["1", "2", "3"];

          const renderedItems = items.map(item => {
            return <Item title={item} />;
          });

          return (
            <div>
              <MDBSortable
                helperClass="helperClass"
                pressDelay={200}
                axis="y"
                items={renderedItems}
                itemClassName="SortableItem"
              />
            </div>
          );
        }

        export default App;
     
        
    
        
            
      .SortableItem {
        font-size: 1rem;
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        cursor: move;
      }
    
      .helperClass {
        box-shadow: 0px 0px 5px 0px rgba(0, 0, 0, 0.5);
      }
    
        
    

Enable sorting only after overcoming a given distance

You can make element to only become sortable after being dragged a certain number of pixels.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import './index.css';

        const Item = props => `Item ${props.title}`;

        function App() {
          const items = ["1", "2", "3"];

          const renderedItems = items.map(item => {
            return <Item title={item} />;
          });

          return (
            <div>
              <MDBSortable
                helperClass="helperClass"
                distance={50}
                axis="y"
                items={renderedItems}
                itemClassName="SortableItem"
              />
            </div>
          );
        }

        export default App;
     
        
    
        
            
      .SortableItem {
        font-size: 1rem;
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        cursor: move;
      }

      .helperClass {
        box-shadow: 0px 0px 5px 0px rgba(0, 0, 0, 0.5);
      }
        
    
        
    

Transition duration

You can set the duration of the transition when elements shift positions.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import './index.css';
        
        const Item = props => `Item ${props.title}`;
        
        function Transition() {
          const defaultItems = ["1", "2", "3"];
        
          const renderedItems = defaultItems.map(item => {
            return <Item title={item} />;
          });
        
          return (
            <div>
              <MDBSortable
                helperClass="helperClass"
                transitionDuration={200}
                axis="y"
                items={renderedItems}
                itemClassName="SortableItem"
              />
            </div>
          );
        }
        
        export default Transition;
        
     
        
    
        
            
      .SortableItem {
        font-size: 1rem;
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        cursor: move;
      }
      
      .helperClass {
        box-shadow: 0px 0px 5px 0px rgba(0, 0, 0, 0.5);
      }
        
    
        
    

Keyboard sorting

You can sort your element using keyboard. To enable it, your element should be focused. Then press "space" and use arrow keys. Press "space" again to finish sorting, press "esc" to cancel sorting.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import "./index.css";
        
        const Item = (props) => `Item ${props.title}`;
        
        function App() {
          const items = ["1", "2", "3", "4", "5", "6", "7", "8", "9"];
        
          const renderedItems = items.map((item) => {
            return <Item title={item} />;
          });
        
          return (
            <div>
              <MDBSortable
                helperClass="helperClass"
                axis="x"
                lockAxis="x"
                items={renderedItems}
                itemClassName="SortableItem"
                listClassName="SortableList"
              />
            </div>
          );
        }
        
        export default App;
        
     
        
    
        
            
      .SortableItem {
        padding: 15px 20px;
        list-style: none;
        background-color: #007bff;
        color: #fff;
        margin: 2px;
        display: flex;
        align-items: center;
        justify-content: flex-start;
        font-size: 1rem;
        cursor: move;
        flex: 1;
      }
      
      .SortableItem:focus {
        border: 1px dotted #eee;
      }
      
      .SortableList {
        display: flex;
      }
      
      .helperClass {
        box-shadow: 0px 0px 5px 0px rgba(0, 0, 0, 0.5);
      }
    
        
    

Sortable deck of cards

You can pass varied components as an items property for Sortable component.

        
            
        import React from "react";
        import MDBSortable from "mdb-react-sortable";
        import {
          MDBBtn,
          MDBCard,
          MDBCardBody,
          MDBCardImage,
          MDBCardTitle,
          MDBCardText,
          MDBCol
        } from "mdbreact";
        import './index.css';

        const Card = props => {
          return (
            <MDBCol>
              <MDBCard>
                <MDBCardImage
                  className="img-fluid"
                  src={`https://mdbootstrap.com/img/Photos/Others/images/${[
                    props.index + 1
                  ]}.webp`}
                  waves
                />
                <MDBCardBody>
                  <MDBCardTitle>Card {props.title}</MDBCardTitle>
                  <MDBCardText>
                    Some quick example text to build on the card title and make up the
                    bulk of the card&apos;s content.
                  </MDBCardText>
                  <MDBBtn href="#">MDBBtn</MDBBtn>
                </MDBCardBody>
              </MDBCard>
            </MDBCol>
          );
        };

        function App() {
          const items = [
            {
              title: "1"
            },
            {
              title: "2"
            },
            {
              title: "3"
            }
          ];
          
          const cards = items.map((item, index) => (
            <Card title={item.title} index={index} />
          ));

          return (
            <div>
              <MDBSortable
                axis="xy"
                items={cards}
                listClassName="SortableList"
              />
            </div>
          );
        }

        export default App;

     
        
    
        
                  
      .SortableList{
        list-style: none;
        display: grid;
        grid-template-columns: repeat(3, 400px);
        justify-content: center;
      }
      
      .helperClass {
        list-style: none;
      }    
    
        
    

React Sortable - API

In this section you will find advanced information about the Sortable plugin.


Download

This plugin requires a purchase.

Buy React Sortable Plugin

Imports

        
            
          import React from 'react';
          import MDBSortable from 'mdb-react-sortable';
        
        
    

API Reference: Sortable Properties

The table below shows the configuration options of the Sortable component.

Name Type Default Description Example
axis String "y" Choose axis for sorting. Possible values: x, y or xy. <Sortable axis="y" />
disableAutoscroll Boolean false Disables autoscrolling while dragging. <Sortable disableAutoscroll={true} />
disabledClassName String Adds class to disabled element. <Sortable disabledClassName="disabledItem" />
distance Number 0 Make elements to only become sortable after being dragged a certain number of pixels. Cannot be used in conjunction with the pressDelay prop. <Sortable distance={50} />
helperClass String Sets a class to the sortable element. <Sortable helperClass="helperClass" />
helperContainer HTMLElement | Function document.body Specify a container for the sortable clone to be appended to. Accepts an HTMLElement or a function returning an HTMLElement that will be invoked before right before sorting begins. By default, the cloned sortable helper is appended to the document body. <Sortable helperContainer={() => {}} />
hideSortableGhost Boolean true Hide the ghost element. By default React Sortable will automatically hide the element that is currently being sorted. Set this to false if you would like to apply your own styling. <Sortable hideSortableGhost={false} />
items Component | Array(Component | String) Sets items to be sorted. If you want to render more then one items collection in one Sortable component, you should set property multipleItems to true. <Sortable items={['1', '2', '3']} />
lockAxis String Locks movement to an axis while sorting. Possible values: x or y. <Sortable lockAxis="y" />
multipleItems Boolean Set it to true when you want render more than one collection in one Sortable component. <Sortable multipleItems />
pressDelay Number 0 Makes elements to only become sortable after being pressed for a certain time, change this property. A good sensible default value for mobile is 200. Cannot be used in conjunction with the distance prop. <Sortable pressDelay={200} />
transitionDuration Number 300 Sets duration of the transition when elements shift positions. Set this to 0 if you'd like to disable transitions. <Sortable transitionDuration={200} />
useWindowAsScrollContainer Boolean false Set the window as the scrolling container. <Sortable useWindowAsScrollContainer />

API Reference: Sortable methods

Name Parameters Description Example
shouldCancelStart event This function is invoked before sorting begins, and can be used to programatically cancel sorting before it begins. By default, it will cancel sorting if the event target is either an input, textarea, select or option. <Sortable shouldCancelStart={() => {}} />
onSortEnd obj, e Callback that is invoked when sorting ends. function({oldIndex, newIndex, collection, isKeySorting}, e) <Sortable onSortEnd={(obj, e) => this.onSortEndHandler(obj, e)} />
onSortMove e Callback that is invoked during sorting as the cursor moves. <Sortable onSortMove={(e) => this.onSortMoveHandler(e)} />
onSortOver obj, e Callback that is invoked when moving over an item. function({index, oldIndex, newIndex, collection, isKeySorting}, e). <Sortable onSortOver={(obj) => this.onSortOverHandler(obj)} />
onSortStart obj, e Callback that is invoked when sorting begins. function({node, index, collection, isKeySorting}, event). <Sortable onSortStart={(obj, e) => this.onSortStartHandler(obj, e)} />

API Reference: Sortable Items Properties

The table below shows the configuration options of the Sortable Item component.
If you want to render a simple elements such as strings ['1', '2'....] or other and want to set one of the property below, you should wrap your items into any component and pass a property to this compopnent.

Name Type Default Description Example
id Number index The element's Index which can used as key. This property is not required. <SortableItem id={id} />
collection Number | String 0 The collection the element is part of. This is useful if you have multiple groups of sortable elements within the same SortableContainer. <SortableItem collection={1} />
disabled Boolean false Whether the element should be sortable or not. <SortableItem disabled />

Vue Bootstrap Sortable

Vue Sortable Plugin - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Vue Bootstrap sortable plugin is an extension that allows you to move, reorder, sort and organize elements on your website by using drag and drop functionality.

To start working with sortable plugin see "API" tab on this page.


Basic Example

Change the order of elements in the DOM tree by dragging the element.

  • Item 1
  • Item 2
  • Item 3
  • Item 4
  • Item 5
  • Item 6
  • Item 7
  • Item 8
        
            
        <template>
          <mdb-container>
            <mdb-list-group>
              <mdb-sortable :list="list">
                <mdb-list-group-item v-for="element in list" :key="element.id" :active="element.active">
                  {{ element.name }}
                </mdb-list-group-item>
              </mdb-sortable>
            </mdb-list-group>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import mdbSortable from 'mdb-sortable'
          import {
            mdbContainer,
            mdbListGroup,
            mdbListGroupItem
          } from 'mdbvue'
          export default {
            name: 'app',
            components: {
              mdbSortable,
              mdbContainer,
              mdbListGroup,
              mdbListGroupItem
            },
            data() {
              return {
                list: [{
                    name: "Item 1",
                    id: 0,
                    active: true
                  },
                  {
                    name: "Item 2",
                    id: 1
                  },
                  {
                    name: "Item 3",
                    id: 2
                  },
                  {
                    name: "Item 4",
                    id: 3
                  },
                  {
                    name: "Item 5",
                    id: 4
                  },
                  {
                    name: "Item 6",
                    id: 5
                  },
                  {
                    name: "Item 7",
                    id: 6
                  },
                  {
                    name: "Item 8",
                    id: 7
                  }
                ]
              }
            }
          }
        </script>
        
        
    

Merging lists

Sorting items between two lists

  • Lion
  • Dog
  • Cat
  • Tiger
  • Fish
  • Bird
  • Falcon
  • Mouse
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col sm="6">
                <mdb-list-group>
                  <mdb-sortable :list="list2" group="merge">
                    <mdb-list-group-item v-for="element in list2" :key="element.id" :active="element.active">
                      {{ element.name }}
                    </mdb-list-group-item>
                  </mdb-sortable>
                </mdb-list-group>
              </mdb-col>
              <mdb-col sm="6">
                <mdb-list-group>
                  <mdb-sortable :list="list3" group="merge">
                    <mdb-list-group-item v-for="element in list3" :key="element.id" :active="element.active">
                      {{ element.name }}
                    </mdb-list-group-item>
                  </mdb-sortable>
                </mdb-list-group>
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import mdbSortable from 'mdb-sortable'
          import {
            mdbContainer,
            mdbRow,
            mdbCol,
            mdbListGroup,
            mdbListGroupItem
          } from 'mdbvue'
          export default {
            name: 'app',
            components: {
              mdbSortable,
              mdbContainer,
              mdbRow,
              mdbCol,
              mdbListGroup,
              mdbListGroupItem
            },
            data() {
              return {
                list2: [{
                    name: "Lion",
                    id: 0,
                    active: true
                  },
                  {
                    name: "Cat",
                    id: 1
                  },
                  {
                    name: "Tiger",
                    id: 2
                  },
                  {
                    name: "Dog",
                    id: 3
                  }
                ],
                list3: [{
                    name: "Fish",
                    id: 4,
                    active: true
                  },
                  {
                    name: "Bird",
                    id: 5
                  },
                  {
                    name: "Falcon",
                    id: 6
                  },
                  {
                    name: "Mouse",
                    id: 7
                  }
                ]
              }
            }
          }
        </script>
        
        
    

Display as grid

Displays items in a sortable grid - this can be used to determine the order in which photos or files are uploaded.

1
2
3
4
5
6
7
8
9
10
11
12
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-sortable :list="list4" class="col-md-5 d-flex flex-center flex-wrap">
                <div v-for="element in list4" :key="element.id" class="text-center white-text blue m-2 square">
                  {{ element.id }}
                </div>
              </mdb-sortable>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import mdbSortable from 'mdb-sortable'
          import {
            mdbContainer,
            mdbRow
          } from 'mdbvue'
          export default {
            name: 'app',
            components: {
              mdbSortable,
              mdbContainer,
              mdbRow
            },
            data() {
              return {
                list4: [{
                    id: 1
                  },
                  {
                    id: 2
                  },
                  {
                    id: 3
                  },
                  {
                    id: 4
                  },
                  {
                    id: 5
                  },
                  {
                    id: 6
                  },
                  {
                    id: 7
                  },
                  {
                    id: 8
                  },
                  {
                    id: 9
                  },
                  {
                    id: 10
                  },
                  {
                    id: 11
                  },
                  {
                    id: 12
                  }
                ]
              }
            }
          }
        </script>
        
        
    
        
            
        <style>
          .square {
            height: 90px;
            width: 90px;
            line-height: 90px;
            font-size: 32px;
          }
        </style>
        
        
    

Handle empty lists

By default, it is not possible to place an item in an empty list. In this example, this has been changed.

From the first list, it is possible to drag to an empty list, while from the second list you cannot drag elements if the target list is empty.

The dropOnEmpty: false parameter is responsible for this behavior.

  • Lion
  • Dog
  • Cat
  • Tiger
  • Fish
  • Bird
  • Falcon
  • Mouse
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col sm="4">
                <mdb-list-group>
                  <mdb-sortable :list="list5" group="empty-lists">
                    <mdb-list-group-item v-for="element in list5" :key="element.id" :active="element.active">
                      {{ element.name }}
                    </mdb-list-group-item>
                  </mdb-sortable>
                </mdb-list-group>
              </mdb-col>
              <mdb-col sm="4">
                <mdb-list-group>
                  <mdb-sortable :list="list6" group="empty-lists">
                    <mdb-list-group-item v-for="element in list6" :key="element.id" :active="element.active">
                      {{ element.name }}
                    </mdb-list-group-item>
                  </mdb-sortable>
                </mdb-list-group>
              </mdb-col>
              <mdb-col sm="4">
                <mdb-list-group class="grey lighten-1 py-2">
                  <mdb-sortable :list="list7" group="empty-lists">
                    <mdb-list-group-item v-for="element in list7" :key="element.id" :active="element.active">
                      {{ element.name }}
                    </mdb-list-group-item>
                  </mdb-sortable>
                </mdb-list-group>
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import mdbSortable from 'mdb-sortable'
          import {
            mdbContainer,
            mdbRow,
            mdbCol,
            mdbListGroup,
            mdbListGroupItem
          } from 'mdbvue'
          export default {
            name: 'app',
            components: {
              mdbSortable,
              mdbContainer,
              mdbRow,
              mdbCol,
              mdbListGroup,
              mdbListGroupItem
            },
            data() {
              return {
                list5: [{
                    name: "Lion",
                    id: 0,
                    active: true
                  },
                  {
                    name: "Dog",
                    id: 1
                  },
                  {
                    name: "Cat",
                    id: 2
                  },
                  {
                    name: "Tiger",
                    id: 3
                  },
                ],
                list6: [{
                    name: "Fish",
                    id: 4,
                    active: true
                  },
                  {
                    name: "Bird",
                    id: 5
                  },
                  {
                    name: "Falcon",
                    id: 6
                  },
                  {
                    name: "Mouse",
                    id: 7
                  }
                ],
                list7: [],
              }
            }
          }
        </script>
        
        
    

Include / exclude items

It is possible to exclude items from the possibility of sorting or dragging items before / after them.

  • I'm sortable
  • I'm not sortable
  • I'm not sortable
  • I'm sortable
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col sm="6">
                <mdb-list-group>
                  <mdb-sortable :list="list12">
                    <mdb-list-group-item v-for="element in list12" :key="element.id" :active="element.active"
                      :disabled="element.disabled">
                      {{ element.name }}
                    </mdb-list-group-item>
                  </mdb-sortable>
                </mdb-list-group>
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import mdbSortable from 'mdb-sortable'
          import {
            mdbContainer,
            mdbRow,
            mdbCol,
            mdbListGroup,
            mdbListGroupItem
          } from 'mdbvue'
          export default {
            name: 'app',
            components: {
              mdbSortable,
              mdbContainer,
              mdbRow,
              mdbCol,
              mdbListGroup,
              mdbListGroupItem
            },
            data() {
              return {
                list12: [{
                    name: "I'm sortable",
                    id: 0,
                    active: true
                  },
                  {
                    name: "I'm sortable",
                    id: 1
                  },
                  {
                    name: "I'm not sortable",
                    id: 2,
                    disabled: true
                  },
                  {
                    name: "I'm not sortable",
                    id: 3,
                    disabled: true
                  }
                ]
              }
            }
          }
        </script>
        
        
    

Sortable collapsed cards

Cards with collapsed content and sorting between lists - similar behavior can be observed on Trello.

Feeds
Lorem ipsum dolor sit amet, consectetuer adipiscing elit
News
Lorem ipsum dolor sit amet, consectetuer adipiscing elit
Shopping
Lorem ipsum dolor sit amet, consectetuer adipiscing elit
Links
Images
Lorem ipsum dolor sit amet, consectetuer adipiscing elit
        
            
        <template>
          <mdb-container>
            <mdb-row>
              <mdb-col sm="4" class="blue mx-auto mb-5 pb-4 white-text">
                <mdb-sortable :list="list8" group="cards">
                  <div class="portlet" v-for="element in list8" :key="element.id">
                    <mdb-btn color="blue" block class="portlet-header white-text blue darken-3 text-capitalize my-3"
                      @click.native="element.collapse ? element.collapse = false : element.collapse = true">
                      {{element.name}} <i class="fas ml-2"
                        :class="element.collapse ? 'fa-caret-up' : 'fa-caret-down'"></i></mdb-btn>
                    <transition @before-enter="beforeEnter" @enter="enter" @before-leave="beforeLeave">
                      <p v-if="element.collapse" class="collapse-item text-center">Lorem ipsum dolor sit amet,
                        consectetuer adipiscing elit</p>
                    </transition>
                  </div>
                </mdb-sortable>
              </mdb-col>
              <mdb-col sm="4" class="blue mx-auto mb-5 pb-4 white-text">
                <mdb-sortable :list="list9" group="cards">
                  <div class="portlet" v-for="element in list9" :key="element.id">
                    <mdb-btn color="blue" block class="portlet-header white-text blue darken-3 text-capitalize my-3"
                      @click.native="element.collapse ? element.collapse = false : element.collapse = true">
                      {{element.name}} <i class="fas ml-2"
                        :class="element.collapse ? 'fa-caret-up' : 'fa-caret-down'"></i></mdb-btn>
                    <transition @before-enter="beforeEnter" @enter="enter" @before-leave="beforeLeave">
                      <p v-if="element.collapse" class="collapse-item text-center">Lorem ipsum dolor sit amet,
                        consectetuer adipiscing elit</p>
                    </transition>
                  </div>
                </mdb-sortable>
              </mdb-col>
              <mdb-col sm="4" class="blue mx-auto mb-5 pb-4 white-text">
                <mdb-sortable :list="list10" group="cards">
                  <div class="portlet" v-for="element in list10" :key="element.id">
                    <mdb-btn color="blue" block class="portlet-header white-text blue darken-3 text-capitalize my-3"
                      @click.native="element.collapse ? element.collapse = false : element.collapse = true">
                      {{element.name}} <i class="fas ml-2"
                        :class="element.collapse ? 'fa-caret-up' : 'fa-caret-down'"></i></mdb-btn>
                    <transition @before-enter="beforeEnter" @enter="enter" @before-leave="beforeLeave">
                      <p v-if="element.collapse" class="collapse-item text-center">Lorem ipsum dolor sit amet,
                        consectetuer adipiscing elit</p>
                    </transition>
                  </div>
                </mdb-sortable>
              </mdb-col>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import mdbSortable from 'mdb-sortable'
          import {
            mdbContainer,
            mdbRow,
            mdbCol,
            mdbListGroup,
            mdbListGroupItem,
            mdbBtn
          } from 'mdbvue'
          export default {
            name: 'app',
            components: {
              mdbSortable,
              mdbRow,
              mdbCol,
              mdbContainer,
              mdbListGroup,
              mdbListGroupItem,
              mdbBtn
            },
            data() {
              return {
                list12: [{
                    name: "I'm sortable",
                    id: 0,
                    active: true
                  },
                  {
                    name: "I'm sortable",
                    id: 1
                  },
                  {
                    name: "I'm not sortable",
                    id: 2,
                    disabled: true
                  },
                  {
                    name: "I'm not sortable",
                    id: 3,
                    disabled: true
                  }
                ]
              }
            },
            methods: {
              beforeEnter(el) {
                el.style.height = 0;
              },
              enter(el) {
                el.style.height = el.scrollHeight + 'px';
              },
              beforeLeave(el) {
                el.style.height = 0;
              }
            }
          }
        </script>
        
        
    

Sortable deck of cards

Cards with collapsed content and sorting between lists - similar behavior can be observed on Trello.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

Card title

Some quick example text to build on the card title and make up the bulk of the card's content.

        
            
        <template>
          <mdb-container>
            <mdb-sortable class="row">
              <mdb-col sm="4" v-for="element in list11" :key="element.id">
                <mdb-card>
                  <mdb-view hover>
                    <a href="#!">
                      <mdb-card-image :src="element.image" alt="Card image cap"></mdb-card-image>
                      <mdb-mask flex-center waves overlay="white-slight"></mdb-mask>
                    </a>
                  </mdb-view>
                  <mdb-card-body>
                    <mdb-card-title>Card title</mdb-card-title>
                    <mdb-card-text>Some quick example text to build on the card title and make up the bulk of the card's
                      content.</mdb-card-text>
                    <mdb-btn color="primary">Read more</mdb-btn>
                  </mdb-card-body>
                </mdb-card>
              </mdb-col>
            </mdb-sortable>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import mdbSortable from 'mdb-sortable'
          import {
            mdbContainer,
            mdbRow,
            mdbCol,
            mdbCard,
            mdbView,
            mdbCardImage,
            mdbMask,
            mdbCardBody,
            mdbCardTitle,
            mdbCardText
          } from 'mdbvue'
          export default {
            name: 'app',
            components: {
              mdbSortable,
              mdbContainer,
              mdbRow,
              mdbCol,
              mdbCard,
              mdbView,
              mdbCardImage,
              mdbMask,
              mdbCardBody,
              mdbCardTitle,
              mdbCardText
            },
            data() {
              return {
                list11: [{
                    image: 'https://mdbootstrap.com/img/Photos/Others/images/14.webp',
                    id: 0
                  },
                  {
                    image: 'https://mdbootstrap.com/img/Photos/Others/images/15.webp',
                    id: 1
                  },
                  {
                    image: 'https://mdbootstrap.com/img/Photos/Others/images/16.webp',
                    id: 2
                  }
                ]
              }
            }
          }
        </script>
        
        
    

Sortable masonry panels

Sortable panels in masonry style. Similar behavior is used in Pinterest.

Panel title that wraps to a new line

This is a longer panel with supporting text below as a natural lead-in to additional content. This content is a little bit longer.

Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.

Someone famous in Source Title
Panel title

This panel has supporting text below as a natural lead-in to additional content.

Last updated 3 mins ago

Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat.

Someone famous in Source Title
Panel title

This panel has supporting text below as a natural lead-in to additional content.

Last updated 3 mins ago

Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.

Someone famous in Source Title
Panel title

This is a wider panel with supporting text below as a natural lead-in to additional content. This panel has even longer content than the first to show that equal height action.

Last updated 3 mins ago

        
            
        <template>
          <mdb-container>
            <mdb-row>
              <div class="card-columns">
                <mdb-sortable>
                  <mdb-card>
                    <mdb-card-body>
                      <mdb-card-title tag="h5">Panel title that wraps to a new line</mdb-card-title>
                      <mdb-card-text>This is a longer panel with supporting text below as a natural lead-in to additional
                        content. This content is a little bit longer.</mdb-card-text>
                    </mdb-card-body>
                  </mdb-card>
                  <mdb-card class="p-3">
                    <blockquote class="blockquote mb-0 card-body">
                      <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat a ante.</p>
                      <footer class="blockquote-footer">
                        <small class="text-muted">
                          Someone famous in <cite title="Source Title">Source Title</cite>
                        </small>
                      </footer>
                    </blockquote>
                  </mdb-card>
                  <mdb-card>
                    <mdb-card-body>
                      <mdb-card-title tag="h5">Panel title</mdb-card-title>
                      <mdb-card-text>This is a longer panel with supporting text below as a natural lead-in to additional
                        content.</mdb-card-text>
                      <mdb-card-text><small class="text-muted">Last updated 3 mins ago</small></mdb-card-text>
                    </mdb-card-body>
                  </mdb-card>
                  <mdb-card class="bg-primary text-white text-center p-3">
                    <blockquote class="blockquote mb-0">
                      <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat.</p>
                      <footer class="blockquote-footer">
                        <small>
                          Someone famous in <cite title="Source Title">Source Title</cite>
                        </small>
                      </footer>
                    </blockquote>
                  </mdb-card>
                  <mdb-card class="text-center">
                    <mdb-card-body>
                      <mdb-card-title tag="h5">Panel title</mdb-card-title>
                      <mdb-card-text>This is a longer panel with supporting text below as a natural lead-in to additional
                        content.</mdb-card-text>
                      <mdb-card-text><small class="text-muted">Last updated 3 mins ago</small></mdb-card-text>
                    </mdb-card-body>
                  </mdb-card>
                  <mdb-card class="text-right p-3">
                    <blockquote class="blockquote mb-0">
                      <p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Integer posuere erat.</p>
                      <footer class="blockquote-footer">
                        <small>
                          Someone famous in <cite title="Source Title">Source Title</cite>
                        </small>
                      </footer>
                    </blockquote>
                  </mdb-card>
                  <mdb-card>
                    <mdb-card-body>
                      <mdb-card-title tag="h5">Panel title</mdb-card-title>
                      <mdb-card-text>This is a longer panel with supporting text below as a natural lead-in to additional
                        content. This panel has even longer content than the first to show that equal height action.
                      </mdb-card-text>
                      <mdb-card-text><small class="text-muted">Last updated 3 mins ago</small></mdb-card-text>
                    </mdb-card-body>
                  </mdb-card>
                </mdb-sortable>
              </div>
            </mdb-row>
          </mdb-container>
        </template>
        
        
    
        
            
        <script>
          import mdbSortable from 'mdb-sortable'
          import {
            mdbContainer,
            mdbRow,
            mdbCol,
            mdbCard,
            mdbView,
            mdbCardImage,
            mdbMask,
            mdbCardBody,
            mdbCardTitle,
            mdbCardText
          } from 'mdbvue'
          export default {
            name: 'app',
            components: {
              mdbSortable,
              mdbContainer,
              mdbRow,
              mdbCol,
              mdbCard,
              mdbView,
              mdbCardImage,
              mdbMask,
              mdbCardBody,
              mdbCardTitle,
              mdbCardText
            }
          }
        </script>
        
        
    
        
            
  
        <style>
          .card-columns {
            -webkit-column-count: 3;
            -moz-column-count: 3;
            column-count: 3;
            -webkit-column-gap: 1.25rem;
            -moz-column-gap: 1.25rem;
            column-gap: 1.25rem;
            orphans: 1;
            widows: 1;
          }
        </style>
        
        
    

Vue Sortable - getting started : download & setup


Download

This plugin requires a purchase.

Buy Vue Sortable Plugin